package Lines;

public class DrawLines {

	public static void Line(ImageViewer v, int px, int py, int qx, int qy)
	{
		int dx = (qx-px);
		int dx2 = dx / 2;
		int dy = (qy-py);
		int dy2 = dy / 2;
		int incx = 1;
		int incy = 1;
		if (dx < 0)
			incx = -1;
		if (dy < 0)
			incy = -1;
		if (dx*incx > dy*incy) // horizontal
		{
			for (int x = px; x != qx+incx; x+= incx)
			{
				// int y = py + (int)((double)(x-px) * (dy) / dx + 0.5);
				int y = py + ((x-px)*dy+dx2)/dx;
				v.dot(x, y);
			}
		}
		else // vertical
		{
			for (int y = py; y != qy+incy; y+= incy)
			{
				// int x = px + (int)((double)(y-py) * (dx) / dy + 0.5); 
				int x = px + ((y-py)*dx+dy2) / dy;
				v.dot(x, y);
			}			
		}
		
		v.line(px,py,qx,qy);
	}
	
	public static void main(String[] args) {
		int w = 1024;
		int h = 768;
		ImageViewer panel = new ImageViewer(w,h);
		Line(panel,0,0,w-1,h-1);
		Line(panel,0,0,w-1,0);
		Line(panel,0,0,0,h-1);
		Line(panel,w-1,0,0,h-1);
		Line(panel,0,h-1,w-1,h-1);
		Line(panel,w-1,0,w-1,h-1);
		panel.repaint();
		/*
		for (int j = 0; j<100; ++j){
			panel.clear();
			for (int i = 0; i<1000; ++i)
			{
				int x0 = (int)(Math.random()*w);
				int y0 = (int)(Math.random()*h);
				int x1 = (int)(Math.random()*w);
				int y1 = (int)(Math.random()*h);
				
				Line(panel, x0,y0,x1,y1);
			}
		panel.repaint();
		}
		*/
		
	}			

}
